#ifndef MAIN_SHADER_H
#define MAIN_SHADER_H

#include "shader.h"
#include "vec.h"

typedef struct shader Shader;
struct shader {
  #include "shader_base.inc"
  M4x4f shadow_matrix;
};

VertexData     general_shader_vertex(void *shader, const VertexData *vert, u8 index, const Model *model);
FragmentResult diffuse_shader_fragment(void *shader, const V3f *barycentric, const V4f *colour,
                                       const Model *model);
FragmentResult albedo_shader_fragment(void *shader, const V3f *barycentric, const V4f *colour,
                                      const Model *model);
#endif // !MAIN_SHADER_H
